searchNodes=[{"doc":"A simple abstraction for standardized observability with telemetry and more.Uplink provides a simple abstraction for configuring observability for libraries and applications. The heart of Uplink is the Uplink.Monitor which provides a standard template for common observability needs such as creating Telemetry.Metrics definitions, telemetry pollers, or setting up other custom observability requirements.The most common challenge when getting started with telemetry is understanding where to start, what all the libraries do, and how they all fit together. This creates a high learning curve while leaving a huge gap at organizations where most developers just want a simple &quot;drop-in&quot; solution for observability that meets the org's requirements.Uplink can be used on its own in simple personal projects or as the basis for a standard &quot;drop-in&quot; library with a simple abstraction containing standard monitors for your organization, such as your Telemetry.Metrics reporter of choice, BEAM VM measurements, or Phoenix measurements, all conforming to your org's metric naming conventions or other standard practices.Usage# application supervisor children = [ { Uplink, [ monitors: [ {MyMonitors.Ecto, [:my_repo]}, Uplink.Monitors.VM ], pollers: [ {10, [{TestModule, :test_emitter, []}]} ], metric_definitions: [ Telemetry.Metrics.counter(&quot;poller.test.event.lasers&quot;) ], reporters: [ Telemetry.Metrics.ConsoleReporter ] ] } ]","ref":"Uplink.html","title":"Uplink","type":"module"},{"doc":"Returns the child spec for running Uplink under a supervisor.Example:children = [ {Uplink, options} ]See options/0 for a list of available options.","ref":"Uplink.html#child_spec/1","title":"Uplink.child_spec/1","type":"function"},{"doc":"An MFA tuple for the poller to execute.","ref":"Uplink.html#t:measurement/0","title":"Uplink.measurement/0","type":"type"},{"doc":"A list of t:TelemetryMetrics.t/0 definitions.","ref":"Uplink.html#t:metric_definitions/0","title":"Uplink.metric_definitions/0","type":"type"},{"doc":"A module or two-element tuple consisting of a module and arguments to be supplied to the monitor. Any arguments passed are passed to all callbacks in the monitor.","ref":"Uplink.html#t:monitor/0","title":"Uplink.monitor/0","type":"type"},{"doc":"","ref":"Uplink.html#t:monitors/0","title":"Uplink.monitors/0","type":"type"},{"doc":"","ref":"Uplink.html#t:option/0","title":"Uplink.option/0","type":"type"},{"doc":"Valid options. No options are required but a monitor and/or monitor are the minimum required to do anything.:metric_definitions - a list of additional Telemetry.Metrics.t/0 definitions not exposed by monitors.:monitors - a list of monitor/0 to use.:poller_specs - a list of additoinal poller_spec/0 not exposed by monitors.:reporters - a list of Telemetry.Metrics reporters, usually 0 or 1.","ref":"Uplink.html#t:options/0","title":"Uplink.options/0","type":"type"},{"doc":"Time in ms between poller executions.Example: :timer.seconds(5)","ref":"Uplink.html#t:period/0","title":"Uplink.period/0","type":"type"},{"doc":"A shorthand specification for listing a number of pollers to be executed at a shared interval.Example: {:timer.seconds(5), [{MyApp.Telemetry, :emit_stats, []}]}","ref":"Uplink.html#t:poller_spec/0","title":"Uplink.poller_spec/0","type":"type"},{"doc":"","ref":"Uplink.html#t:poller_specs/0","title":"Uplink.poller_specs/0","type":"type"},{"doc":"A module or two-element tuple consisting of a reporter and arguments to be passed to the reporter,Example: {TelemetryMetricsPrometheus, [port: 9568]}","ref":"Uplink.html#t:reporter_spec/0","title":"Uplink.reporter_spec/0","type":"type"},{"doc":"","ref":"Uplink.html#t:reporter_specs/0","title":"Uplink.reporter_specs/0","type":"type"},{"doc":"A behaviour module for implementing a library or application monitor.Uplink Monitors provide a template for the most common requirements to instrument a library or application in a consistent manner. These provide a simple abstraction for building standard observability patterns for whatever is being monitored while removing the need for users to repeatedly define and configure things like TelemetryMetrics definitions.There are three required callbacks which make up a monitor. The provided macro provides default implementations for each, allowing you to only implement what is needed for a particular monitor.Each callback receives the same argument defined in Uplink.monitor/0.Usagedefmodule MyApp.CustomMonitor do using Uplink.Monitor # override any callbacks you need @impl true def init(_) do # some setup :ok end @impl true def metric_definitions(_) do [Telemetry.Metrics.counter(&quot;some.event&quot;)] end @impl true def poller_specs(_) do [ {:timer.seconds(5), [ {MyApp.Telemetry, :emit_stats, []} ]} ] endSee Uplink.Monitors.VM for an example implementation.","ref":"Uplink.Monitor.html","title":"Uplink.Monitor","type":"behaviour"},{"doc":"Invoked when Uplink is starting.It is useful for initializing any custom monitoring for the library or application being monitored. Examples include creating telemetry handlers to log slow Ecto queries which exceed a threshold or starting an OpenTelemetry bridge library.If the function returns :error, Uplink will exit.This callback is required.","ref":"Uplink.Monitor.html#c:init/1","title":"Uplink.Monitor.init/1","type":"callback"},{"doc":"Invoked when Uplink is starting.It is useful for providing a standard set of Telemetry.Metrics.t/0 definitions for the library or application being monitored.This callback is required.","ref":"Uplink.Monitor.html#c:metric_definitions/1","title":"Uplink.Monitor.metric_definitions/1","type":"callback"},{"doc":"Invoked when Uplink is starting.It is useful for providing a standard set of telemetry_pollers for the library or application being monitored. Examples include emitting cache sizes, memory usage, or process counts.This callback is required.","ref":"Uplink.Monitor.html#c:poller_specs/1","title":"Uplink.Monitor.poller_specs/1","type":"callback"},{"doc":"Provides telemetry events, pollers for emitting those events, and definitions for BEAM VM statistics in addition to the builtins available telemetry_poller vm statistics.Telemetry[:vm, :stats]Description: Emits BEAM system statisticsMeasurements: %{ context_switches: non_neg_integer, gc_count: non_neg_integer, gc_bytes_reclaimed: non_neg_integer, io_in: non_neg_integer, io_out: non_neg_integer, reductions: non_neg_integer }Metadata: %{}[:vm, :system_limits]Description: Emits BEAM system limitsMeasurements: %{ atom_limit: non_neg_integer, port_limit: non_neg_integer, process_limit: non_neg_integer }Metadata: %{}","ref":"Uplink.Monitors.VM.html","title":"Uplink.Monitors.VM","type":"module"},{"doc":"","ref":"Uplink.Monitors.VM.html#emit_stats/0","title":"Uplink.Monitors.VM.emit_stats/0","type":"function"},{"doc":"","ref":"Uplink.Monitors.VM.html#emit_system_limits/0","title":"Uplink.Monitors.VM.emit_system_limits/0","type":"function"},{"doc":"UplinkUplink makes setup of application monitoring with telemetry as simple as possible. Rather than having to add and setup several libraries, this package rolls them all up into a single configurable drop-in to your application tree.","ref":"readme.html","title":"Uplink","type":"extras"},{"doc":"def deps do [ {:uplink, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Uplink - Installation","type":"extras"},{"doc":"Add Uplink to your application supervision tree and tell it which monitors it should run. # application supervisor children = [ { Uplink, [ monitors: [ {MyMonitors.Ecto, [repo_prefix: :my_repo]}, Uplink.Monitors.VM ], pollers: [ {10, [{TestModule, :test_emitter, []}]} ], metric_definitions: [ Telemetry.Metrics.counter(&quot;poller.test.event.lasers&quot;) ], reporters: [ Telemetry.Metrics.ConsoleReporter ] ] } ]See the docs for more information.","ref":"readme.html#usage","title":"Uplink - Usage","type":"extras"},{"doc":"Monitors by the community, for the community!","ref":"readme.html#uplink-monitors","title":"Uplink - Uplink Monitors","type":"extras"},{"doc":"Uplink Monitors are meant to be copied and pasted into your project as a starting point because preferences amongst individuals and organizations around metrics can vary widely. The important thing is to have a jumping-off point and can learn patterns and practices from others. These aren't one-size-fits-all, so make them your own and share your learnings with others!In the monitors folder you'll find monitors for popular libraries which have been compiled over the past few years. They've worked quite well, so enjoy!Create a PR to add a link to your own examples in the README or a monitor for a library not already covered.Community LinksCopyright (c) 2021 Bryan Naegele","ref":"readme.html#usage","title":"Uplink - Usage","type":"extras"}]